<template>
  <div>
    <PageCard>
      <ThePart1
        @close="close"
        @finish="crossroads"></ThePart1>
      <TheWarning></TheWarning>
    </PageCard>
    <h2 class="signIn_step-pretitle">{{$t('authorization.step3.subtitle')}}</h2>
    <PageCard>
      <ThePart2 @finish="crossroads"></ThePart2>
      <ThePart3 @finish="crossroads"></ThePart3>
      <ThePart4 @finish="crossroads"></ThePart4>
    </PageCard>
    <Loader
      ref="loader"
      :timeToLoad="7000"
      :loadFunc="accountCreated">{{loadingText}}
    </Loader>
    <TheActivatedDialog
      @close="$emit('close')"
      ref="activated"></TheActivatedDialog>
  </div>
</template>

<script>
  import ThePart1 from './notExisted/dublicates/ThePart1';
  import ThePart2 from './notExisted/dublicates/ThePart2';
  import ThePart3 from './notExisted/dublicates/ThePart3';
  import ThePart4 from './notExisted/dublicates/ThePart4';
  import TheWarning from './notExisted/dublicates/TheWarning';
  import {Wallet} from "~/services/wallet";
  import Loader from '~/components/UI/Loader';
  import PageCard from '~/components/UI/PageCard';
  import mixin_signIn from "~/components/signIn/mixin_utils";
  import TheActivatedDialog from '~/components/deposit/TheActivatedDialog';

  import to from 'await-to-js';

  export default {
    name: "Deposit_TheStep3",
    mixins: [mixin_signIn],
    data() {
      return {
        loadingText: 'Creating...',
        accountCreated: () => false,
        content: ''
      }
    },
    components: {
      ThePart1,
      ThePart2,
      ThePart3,
      ThePart4,
      TheWarning,
      Loader,
      PageCard,
      TheActivatedDialog
    },
    methods: {
      close() {
        this.$emit('close');
      },
      async crossroads(keys) {
        this.finishRegistration(keys);
      },
      async finishRegistration(keys) {
        this.loadingText = this.$t('authorization.checking');;
        this.$refs['loader'].show();
        let [err, res] = await to(this.$store.dispatch('signIn/getAccountByKey', {
          publicKey: keys.publicKeys[0],
          network: 'mainnet'
        }));
        if (err) {
          let accountToCreate = localStorage.getItem('accountname');
          accountToCreate = await this.mixin_checkOrGenerateName(accountToCreate, 12, 'mainnet', false);
          this.createUser(keys, accountToCreate);
        } else {
          this.loadingText = 'Account already exists, aborting...';
          setTimeout(_ => {
            this.clearLoader();
          }, 3000);
        }
      },
      async pause(ms) {
        return new Promise((resolve, reject) => {
          setTimeout(_ => {
            resolve();
          }, ms);
        })
      },
      async createUser(keys, accountName) {
        this.loadingText = 'Activating...';
        const [e, r] = await to(this.$store.dispatch('user/create', {
          net: 'mainnet',
          username: accountName,
          public: {
            owner: keys.publicKeys[1] ? keys.publicKeys[1] : keys.publicKeys[0],
            active: keys.publicKeys[0],
          },
          signature: 'sign',
          timestamp: new Date().getTime()
        }));
        setTimeout(_ => {
          this.$store.dispatch('wallet/getAccount', {
            accountName,
            needCheckExisting: false
          });
          this.clearLoader();
          if (!e) {
            this.$refs['activated'].show();
          }
        }, 5000);
      },
      clearLoader() {
        this.accountCreated = () => true;
      },
    }
  }
</script>
